<?php
/**
 * @Copyright
 * @package        EasyCalcCheck Captcha - ECCC for Joomla! 3
 * @author         Viktor Vogel <admin@kubik-rubik.de>
 * @version        3.1.0 - 2018-07-17
 * @link           https://joomla-extensions.kubik-rubik.de/ecc-easycalccheck-plus
 *
 * @license        GNU/GPL
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
defined('_JEXEC') || die('Restricted access');

class PlgCaptchaEasyCalcCheckCaptchaInstallerScript
{
    /**
     * Checks compatibility in the preflight event
     *
     * @param $type
     * @param $parent
     *
     * @return bool
     * @throws Exception
     */
    public function preflight($type, $parent)
    {
        // First check whether version requirements are met for this specific version
        if (!$this->checkVersionRequirements('3.8', 'EasyCalcCheck Captcha')) {
            return false;
        }
    }

    /**
     * Checks whether all requirements are met for the execution
     * Written generically to be used in all Kubik-Rubik Joomla! Extensions
     *
     * @param string $versionMin    Minimum required Joomla! version - e.g. 3.2
     * @param string $extensionName Name of the extension of the warning message
     *
     * @return bool
     * @throws Exception
     */
    private function checkVersionRequirements($versionMin, $extensionName)
    {
        $version = new JVersion();

        if (!$version->isCompatible($versionMin)) {
            JFactory::getApplication()->enqueueMessage(JText::sprintf('KR_JOOMLA_VERSION_REQUIREMENTS_NOT_MET_INSTALLATION', $extensionName, $versionMin), 'error');

            return false;
        }

        return true;
    }
}